//TURKEYS
//Add objects, for turkey parent object
object_event_add(Turkey,ev_create,0,'
//Set values for all, save lines. Change specific properties by object basis
event_user(11)

//Animation
sprite_index=TurkeyNormalIdleS
mask_index=TurkeyNormalMaskM
idleSprite=TurkeyNormalIdleS
walkSprite=TurkeyNormalS
flySprite=TurkeyNormalFlyS
//FIX: characterHitObstacle needs these variables defined
left_bound_offset = sprite_get_bbox_left(sprite_index)-sprite_get_xoffset(sprite_index);
right_bound_offset = sprite_get_bbox_right(sprite_index)-sprite_get_xoffset(sprite_index);
top_bound_offset = sprite_get_bbox_top(sprite_index)-sprite_get_yoffset(sprite_index);
bottom_bound_offset = sprite_get_bbox_bottom(sprite_index)-sprite_get_yoffset(sprite_index);

//State
turkeyType=0

//Gamemode
weight=1
giveScore=1
')
object_event_add(Turkey,ev_alarm,0,'
if !global.isHost exit;
if beingCarried!=0 exit;

event_user(0)

//Randomly choose state
var rand;
rand=irandom(5)
if rand==0 idle=1
else if rand==1 walkingLeft=1
else if rand==2 walkingRight=1
else if rand==3 runningLeft=1
else if rand==4 runningRight=1

//Jumping handled separately
if turkeyType==2{
    jumping=choose(0,1) //1/2 chance of jumping for pyro turkey
}else{
    jumping=choose(0,0,0,0,0,1,1,1) //3/8 chance of jumping
}

with(Character){
    testDist = distance_to_object(other)
    if(testDist<=100){
        //if character x is greater than turkey x (on the right of turkey)
        if x>other.x{
            with(other){
                var avoidRand;
                avoidRand=irandom(6)
                if avoidRand==0{
                    idle=1
                }else if avoidRand>0{
                    runningLeft=1
                    runningRight=0
                    walkingRight=0
                }
            }
        }
        //if character x is less than turkey x (on the left of turkey)
        if x<other.x{
            with(other){
                var avoidRand;
                avoidRand=irandom(6)
                if avoidRand==0{
                    idle=1
                }else if avoidRand>0{
                    runningRight=1
                    runningLeft=0
                    walkingLeft=0
                }
            }
        }
    }
}

alarm[0]=irandom_range(1,180)
')
object_event_add(Turkey,ev_alarm,2,'
//Just incase they get stuck
if oldX=x{
    alarm[0]=1
}

oldX=x

alarm[2]=270
')
object_event_add(Turkey,ev_alarm,5,'
//Reset dropped state
justDropped=0
')
object_event_add(Turkey,ev_alarm,6,'
var rand;
rand=irandom(12)
if rand==0{
    playsound(x,y,TurkeyGobbleSnd)
}
alarm[6]=irandom_range(90,600)
')
object_event_add(Turkey,ev_step,ev_step_normal,'
//Collision code
//FIX: Function changed from now non existant charSetAllSolids to charSetSolids
charSetSolids();
wallSetSolid()

if captured==1{
    with(TurkeyPen){
        solid=true
    }
}

if(!place_free(x+hspeed, y+vspeed)){
    characterHitObstacle()
}

//Gravity
_gravity=0.35
if place_free(x,y-_gravity) and (place_free(x,y+1) or vspeed<0){
    vspeed+=_gravity
}

//Fall if turkeys hit their heads
if !place_free(x,y-1){
    vspeed+=_gravity
}

//FIX: Function changed from now non existant allUnsetSolids to charUnsetSolids
charUnsetSolids();

if captured==1{
    with(TurkeyPen){
        solid=false
    }
}
')
object_event_add(Turkey,ev_step,ev_step_begin,'
//Movement
if idle==1{
    hspeed/=frictionFactor
}
if walkingLeft==1{
    hspeed-=walkPower*controlFactor
}
if walkingRight==1{
    hspeed+=walkPower*controlFactor
}
if runningLeft==1{
    hspeed-=runPower*controlFactor
}
if runningRight==1{
    hspeed+=runPower*controlFactor
}
if jumping==1{
    vspeed-=jumpStrength
    if turkeyType==2 and beingCarried==0{
        event_user(1)
    }
    jumping=0
}

//Cap speed
//Running
if runningLeft==1 or runningRight==1{
    if abs(hspeed)>maxRunSpeed{
        if hspeed>0{
            hspeed=min(hspeed,maxRunSpeed)
        }else if hspeed<0{
            hspeed=max(hspeed,maxRunSpeed*-1)
        }
    }
}
//Walking
if walkingLeft==1 or walkingRight==1{
    if abs(hspeed)>maxWalkSpeed{
        if hspeed>0{
            hspeed=min(hspeed,maxWalkSpeed)
        }else if hspeed<0{
            hspeed=max(hspeed,maxWalkSpeed*-1)
        }
    }
}
//Vertical
if place_free(x,y+1){
    if vspeed<0{ //Moving up
        vspeed=max(vspeed,maxVspeed*-1)
    }else if vspeed>0{ //Falling
        vspeed=min(vspeed,maxFallSpeed)
    }
}

//Movestatus
if moveStatus==0{
    frictionFactor=1.15
}else if moveStatus==4{
    frictionFactor=1
}
//RJ particles
if(moveStatus==4){
    if !variable_local_exists("jumpFlameParticleType"){
        jumpFlameParticleType = part_type_create();
        part_type_sprite(jumpFlameParticleType,FlameS,true,false,true);
        part_type_alpha2(jumpFlameParticleType,1,0.3);
        part_type_life(jumpFlameParticleType,2,5);
        part_type_scale(jumpFlameParticleType,0.7,-0.65);
    }
    vspeed -= 0.06 * global.delta_factor;
    
    if !variable_global_exists("jumpFlameParticleSystem"){
        global.jumpFlameParticleSystem = part_system_create();
        part_system_depth(global.jumpFlameParticleSystem, 10);
    }
    
    if(global.particles == PARTICLES_NORMAL){
        if(random(1) > (controlFactor+frictionFactor)/2){
            effect_create_below(ef_smoke,x-hspeed*1.2,y-vspeed*1.2+20,0,c_gray);
        }
    }
    if(global.particles == PARTICLES_NORMAL or global.particles == PARTICLES_ALTERNATIVE){
        if(random(7) < 5){
            part_particles_create(global.jumpFlameParticleSystem,x,y+19,jumpFlameParticleType,1);
        }
    }
}

//Stop turkeys going outside of map
if(x<0) {
    x=0;
}
if(x>map_width()){
    x = map_width();
}
if(y<0) {
    y = 0;
}
if(y>map_height()){
    y = map_height();
}

if beingCarried==1{
    event_user(0)
}

//Special turkeys behaviour
if beingCarried==0{
    event_user(1)
}

if turkeyType==4 and beingCarried==1{
    event_user(1)
}
')
object_event_add(Turkey,ev_step,ev_step_end,'
//Animation
if vspeed>0{
    sprite_index=flySprite
    image_speed=0.5
}else if hspeed!=0{
    sprite_index=walkSprite
    image_speed=0
}else if hspeed==0{
    sprite_index=idleSprite
    image_speed=0
}

nextFrameCounter+=abs(hspeed)
//Change to next frame of walk
if nextFrameCounter>=6{
    image_index+=1
    nextFrameCounter=0
}
//Flip sprite for movement direction
if hspeed>0{
    image_xscale=1
}

if hspeed<0{
    image_xscale=-1
}

//Carrying, dropped
if !instance_exists(carryingPlayer) and carryingPlayer!=noone{
    carryingPlayer=noone
    beingCarried=0
}
//Floating around player
if beingCarried==1{
    if global.isHost==1{
        if beingCarried==1{
            carryingPlayerX=carryingPlayer.x
            carryingPlayerY=carryingPlayer.y
        }else{
            carryingPlayerX=0
            carryingPlayerY=0
        }
    }
    x=median(carryingPlayerX-5,x,carryingPlayerX+5)+turkeyOffset
    y=median(carryingPlayerY-5,y,carryingPlayerY+5)+turkeyOffset/4
    turkeyOffset+=turkeyDir
    if (abs(turkeyOffset)>10){
        turkeyDir*=-1
    }
    
    moveStatus=0
    image_alpha=1
}


//Ubered players cant carry turkeys
//if beingCarried==1{
//    if carryingPlayer.ubered==1{
//        event_user(10)
//    }
//}
')
object_event_add(Turkey,ev_collision,Character,'
//Medic turkey ability
if turkeyType==6 and beingCarried==0 and captured==0{
    if other.player.object.turkeyCarryingWeight!=0{
        with(other){
            with(Turkey){
                if carryingPlayer==global.myself.object{
                    //Prevent the medic turkey from being picked up instantly, but can be picked up quicker
                    event_user(10)
                    alarm[5]=pickupDelay/2
                }
            }
        }
    }
}

//Enemy steal turkeys from pen
if captured==1{
    if instance_nearest(x,y,TurkeyPen).team!=other.player.team{
        if other.player.object.turkeyCarryingWeight<2{
            if other.player.object.turkeyCarryingWeight+weight<=2{
                captured=0
                if instance_nearest(x,y,TurkeyPen).team==TEAM_RED{
                    global.redCaps-=giveScore
                }else if instance_nearest(x,y,TurkeyPen).team==TEAM_BLUE{
                    global.blueCaps-=giveScore
                }
            }
        }
    }
}

//Pick up wild turkey
if justDropped==1 exit;
if beingCarried==0 and captured==0 and other.player.object.ubered==0{
    if other.player.object.turkeyCarryingWeight<2{
        if other.player.object.turkeyCarryingWeight+weight<=2{
            event_user(0)
            carryingPlayer=other.player.object
            beingCarried=1
            carryingPlayer.turkeyCarryingWeight+=weight
            //Set oldRunPower for heavy turkey
            if turkeyType==4{
                oldRunPower=carryingPlayer.runPower
            }
        }
    }
}
')
object_event_add(Turkey,ev_collision,Sentry,'
//Turkey walks into sentry, teleports them to owner
if justDropped==1 exit;
if beingCarried==0 and captured==0{
    if other.ownerPlayer.object.turkeyCarryingWeight<2{
        if other.ownerPlayer.object.turkeyCarryingWeight+weight<=2{
            x=other.ownerPlayer.object.x
            y=other.ownerPlayer.object.y
        }
    }
}
')
object_event_add(Turkey,ev_collision,TurkeyPen,'
if !global.isHost exit;

//Capture turkey
if captured==0 and beingCarried==1{
    if other.team==carryingPlayer.team{
        //Fake turkey
        if turkeyType==11{
            carryingPlayer.turkeyCarryingWeight-=weight
            //FIX: Sometimes a players carrying weight goes below zero so this resolves that problem so a player can not have more than two turkeys
            if(carryingPlayer.turkeyCarryingWeight < 0){
                carryingPlayer.turkeyCarryingWeight = 0;
            }
            event_user(2)
            exit;
        }
        captured=1
        carryingPlayer.turkeyCarryingWeight-=weight
        //FIX: Sometimes a players carrying weight goes below zero so this resolves that problem so a player can not have more than two turkeys
        if(carryingPlayer.turkeyCarryingWeight < 0){
            carryingPlayer.turkeyCarryingWeight = 0;
        }
        
        //Reset speed for carrying heavy turkey
        if turkeyType==4{
            carryingPlayer.runPower=oldRunPower
        }
        
        beingCarried=0
        carryingPlayer=noone
        x=other.x
        y=other.y
        alarm[5]=30
        
        if other.team==TEAM_RED{
            global.redCaps+=giveScore
        }else if other.team==TEAM_BLUE{
            global.blueCaps+=giveScore
        }
    }
}
')object_event_add(Turkey,ev_other,ev_user0,'
//Reset turkey state
idle=0
walkingLeft=0
walkingRight=0
runningLeft=0
runningRight=0
jumping=0
')
object_event_add(Turkey,ev_other,ev_user1,'
//Change turkeys to their correct objects
if turkeyType==1{
    instance_change(TurkeyScout,1)
}
if turkeyType==2{
    instance_change(TurkeyPyro,1)
}
if turkeyType==3{
    instance_change(TurkeySoldier,1)
}
if turkeyType==4{
    instance_change(TurkeyHeavy,1)
}
if turkeyType==5{
    instance_change(TurkeyDemo,1)
}
if turkeyType==6{
    instance_change(TurkeyMedic,1)
}
if turkeyType==7{
    instance_change(TurkeyEngie,1)
}
if turkeyType==8{
    instance_change(TurkeySpy,1)
}
if turkeyType==9{
    instance_change(TurkeySniper,1)
}
if turkeyType==10{
    instance_change(TurkeyQuote,1)
}

if turkeyType>11{
    turkeyType=0
}
')
object_event_add(Turkey,ev_other,ev_user10,'
//Drop turkey
if captured==0 and beingCarried==1{
    carryingPlayer.turkeyCarryingWeight-=weight
    //FIX: Sometimes a players carrying weight goes below zero so this resolves that problem so a player can not have more than two turkeys
    if(carryingPlayer.turkeyCarryingWeight < 0){
        carryingPlayer.turkeyCarryingWeight = 0;
    }
        
    //Reset speed for carrying heavy turkey
    if turkeyType==4{
        carryingPlayer.runPower=oldRunPower
    }
    //Inherit momentum from player, allows throwing of turkeys
    hspeed+=carryingPlayer.hspeed
    vspeed+=carryingPlayer.vspeed
        
    beingCarried=0
    carryingPlayer=noone
    justDropped=1
    alarm[5]=pickupDelay
}
')
object_event_add(Turkey,ev_other,ev_user11,'
//FIX: charSetSolids and charUnsetSolids needs a team and intel set
team = -1;
intel = 0;

//Behaviours
idle=0
walkingLeft=0
walkingRight=0
runningLeft=0
runningRight=0
jumping=0

//Movement values
jumpStrength=7
runPower=0.5
walkPower=0.2
controlFactor=0.85
frictionFactor=1.15
maxRunSpeed=abs(runPower*controlFactor/(frictionFactor-1))
maxWalkSpeed=abs(walkPower*controlFactor/(frictionFactor-1))
maxVspeed=maxRunSpeed*2
maxFallSpeed=maxRunSpeed
moveStatus=0

//Animation
image_speed=0
nextFrameCounter=0
turkeyOffset=0
turkeyDir=0.5
alarm[0]=irandom_range(1,180)
depth=-2

//State
beingCarried=0
carryingPlayer=noone
captured=0
justDropped=0
carryingPlayerX=0
carryingPlayerY=0
pickupDelay=30

//Become unstuck
oldX=x
alarm[2]=270

//Sound
alarm[6]=irandom_range(90,600)
')
object_event_add(Turkey,ev_other,ev_user14,'
write_ushort(TurkeyPlugin.sendBuffer,x*5);
write_ushort(TurkeyPlugin.sendBuffer,y*5);
write_ubyte(TurkeyPlugin.sendBuffer,beingCarried);
if (carryingPlayer == noone)
    write_uint(TurkeyPlugin.sendBuffer, 256);
else
    write_uint(TurkeyPlugin.sendBuffer, ds_list_find_index(global.players,carryingPlayer.player));
write_ubyte(TurkeyPlugin.sendBuffer,captured);
write_ubyte(TurkeyPlugin.sendBuffer,turkeyType);
write_ushort(TurkeyPlugin.sendBuffer,carryingPlayerX*5);
write_ushort(TurkeyPlugin.sendBuffer,carryingPlayerY*5);
write_byte(TurkeyPlugin.sendBuffer,hspeed*8.5);
write_byte(TurkeyPlugin.sendBuffer,vspeed*8.5);
')
object_event_add(Turkey,ev_other,ev_user15,'
x=read_ushort(TurkeyPlugin.recBuff)/5;
y=read_ushort(TurkeyPlugin.recBuff)/5;
beingCarried=read_ubyte(TurkeyPlugin.recBuff);
carryingPlayer = ds_list_find_value(global.players, read_uint(TurkeyPlugin.recBuff));
if (carryingPlayer == -1)
{
    carryingPlayer = noone;
}
//else
//{
//    carryingPlayer = carryingPlayer.object;
//}
captured=read_ubyte(TurkeyPlugin.recBuff);
turkeyType=read_ubyte(TurkeyPlugin.recBuff);
carryingPlayerX=read_ushort(TurkeyPlugin.recBuff)/5;
carryingPlayerY=read_ushort(TurkeyPlugin.recBuff)/5;
hspeed=read_byte(TurkeyPlugin.recBuff)/8.5;
vspeed=read_byte(TurkeyPlugin.recBuff)/8.5;
')
object_event_add(Turkey,ev_draw,0,'
draw_sprite_ext(sprite_index,image_index,x,y,image_xscale,image_yscale,image_angle,c_white,image_alpha)
')

//SPECIAL TURKEYS
//Scout turkey
globalvar TurkeyScout;
TurkeyScout=object_add()
object_event_add(TurkeyScout,ev_create,0,'
//Set values for all, save lines. Change specific properties by object basis
event_user(11)

//Movement values
jumpStrength=10
runPower=1
walkPower=0.4

//Animation
sprite_index=TurkeyScoutIdleS
mask_index=TurkeyScoutMaskM
idleSprite=TurkeyScoutIdleS
walkSprite=TurkeyScoutS
flySprite=TurkeyScoutFlyS
//FIX: characterHitObstacle needs these variables defined
left_bound_offset = sprite_get_bbox_left(sprite_index)-sprite_get_xoffset(sprite_index);
right_bound_offset = sprite_get_bbox_right(sprite_index)-sprite_get_xoffset(sprite_index);
top_bound_offset = sprite_get_bbox_top(sprite_index)-sprite_get_yoffset(sprite_index);
bottom_bound_offset = sprite_get_bbox_bottom(sprite_index)-sprite_get_yoffset(sprite_index);

//State
turkeyType=1

//Gamemode
weight=1
giveScore=2

//Special
canSprint=0
sprintTime=150
sprintCooldown=210
alarm[3]=sprintCooldown
sprintPower=2
sprinting=0
maxSprintSpeed=abs(sprintPower*controlFactor/(frictionFactor-1))
oldMaxRunSpeed=abs(runPower*controlFactor/(frictionFactor-1))
oldRunPower=runPower
')
object_event_add(TurkeyScout,ev_alarm,1,'
canSprint=0
sprinting=0
idle=1
maxRunSpeed=oldMaxRunSpeed
runPower=oldRunPower
alarm[3]=sprintCooldown
')
object_event_add(TurkeyScout,ev_alarm,3,'
canSprint=1
')
object_event_add(TurkeyScout,ev_other,ev_user1,'
if distance_to_object(Character)<=150 and canSprint==1{
    sprinting=1
    maxRunSpeed=maxSprintSpeed
    runPower=sprintPower
    if hspeed>0{
        runningRight=1
    }
    if hspeed<0{
        runningLeft=1
    }
    alarm[1]=sprintTime
}
')

//Pyro turkey
globalvar TurkeyPyro;
TurkeyPyro=object_add()
object_event_add(TurkeyPyro,ev_create,0,'
//Set values for all, save lines. Change specific properties by object basis
event_user(11)

//Animation
sprite_index=TurkeyPyroIdleS
mask_index=TurkeyPyroMaskM
idleSprite=TurkeyPyroIdleS
walkSprite=TurkeyPyroS
flySprite=TurkeyPyroFlyS
//FIX: characterHitObstacle needs these variables defined
left_bound_offset = sprite_get_bbox_left(sprite_index)-sprite_get_xoffset(sprite_index);
right_bound_offset = sprite_get_bbox_right(sprite_index)-sprite_get_xoffset(sprite_index);
top_bound_offset = sprite_get_bbox_top(sprite_index)-sprite_get_yoffset(sprite_index);
bottom_bound_offset = sprite_get_bbox_bottom(sprite_index)-sprite_get_yoffset(sprite_index);

//State
turkeyType=2

//Gamemode
weight=1
giveScore=2

//Special
airblastRange=70
')
object_event_add(TurkeyPyro,ev_other,ev_user1,'
//Airblast
if jumping!=1 exit;
if captured==1 exit;
with(Character){
    dir=point_direction(other.x,other.y,x,y)
    dist=point_distance(other.x,other.y,x,y)
    if distance_to_object(other)<=other.airblastRange{
        motion_add(dir,15*(1-dist/150))
        vspeed -= 2
        moveStatus = 3
    }
}

with(Turkey){
    if self!=other{
        dir=point_direction(other.x,other.y,x,y)
        dist=point_distance(other.x,other.y,x,y)
        if distance_to_object(other)<=other.airblastRange{
            motion_add(dir,15*(1-dist/150))
            vspeed -= 2
            moveStatus = 3
        }
    }
}

with(Rocket){
    dir=point_direction(other.x,other.y,x,y)
    dist=point_distance(other.x,other.y,x,y)
    if distance_to_object(other)<=other.airblastRange{
        motion_add(dir,15*(1-dist/150))
        vspeed -= 2
        moveStatus = 3
    }
}

with(Mine){
    dir=point_direction(other.x,other.y,x,y)
    dist=point_distance(other.x,other.y,x,y)
    if distance_to_object(other)<=other.airblastRange{
        motion_add(dir,15*(1-dist/150))
        vspeed -= 2
        moveStatus = 3
    }
}

with(Shot){
    dir=point_direction(other.x,other.y,x,y)
    dist=point_distance(other.x,other.y,x,y)
    if distance_to_object(other)<=other.airblastRange{
        motion_add(dir,15*(1-dist/150))
        vspeed -= 2
        moveStatus = 3
    }
}

with(BurningProjectile){
    dir=point_direction(other.x,other.y,x,y)
    dist=point_distance(other.x,other.y,x,y)
    if distance_to_object(other)<=other.airblastRange{
        motion_add(dir,15*(1-dist/150))
        vspeed -= 2
        moveStatus = 3
    }
}

with(BladeB){
    dir=point_direction(other.x,other.y,x,y)
    dist=point_distance(other.x,other.y,x,y)
    if distance_to_object(other)<=other.airblastRange{
        motion_add(dir,15*(1-dist/150))
        vspeed -= 2
        moveStatus = 3
    }
}

with(Needle){
    dir=point_direction(other.x,other.y,x,y)
    dist=point_distance(other.x,other.y,x,y)
    if distance_to_object(other)<=other.airblastRange{
        motion_add(dir,15*(1-dist/150))
        vspeed -= 2
        moveStatus = 3
    }
}
')
//Soldier turkey
globalvar TurkeySoldier;
TurkeySoldier=object_add()
object_event_add(TurkeySoldier,ev_create,0,'
//Set values for all, save lines. Change specific properties by object basis
event_user(11)

//Movement values
maxVspeed=maxRunSpeed*4

//Animation
sprite_index=TurkeySoldierIdleS
mask_index=TurkeySoldierMaskM
idleSprite=TurkeySoldierIdleS
walkSprite=TurkeySoldierS
flySprite=TurkeySoldierFlyS
//FIX: characterHitObstacle needs these variables defined
left_bound_offset = sprite_get_bbox_left(sprite_index)-sprite_get_xoffset(sprite_index);
right_bound_offset = sprite_get_bbox_right(sprite_index)-sprite_get_xoffset(sprite_index);
top_bound_offset = sprite_get_bbox_top(sprite_index)-sprite_get_yoffset(sprite_index);
bottom_bound_offset = sprite_get_bbox_bottom(sprite_index)-sprite_get_yoffset(sprite_index);

//State
turkeyType=3

//Gamemode
weight=1
giveScore=2

//Special
canRocketJump=0
rocketJumpCooldown=150
rocketJumpStrength=20
alarm[1]=rocketJumpCooldown
')
object_event_add(TurkeySoldier,ev_alarm,1,'
canRocketJump=1
')
object_event_add(TurkeySoldier,ev_other,ev_user1,'
//Rocket jump
if (distance_to_object(Character)<=40) and (canRocketJump==1){
    moveStatus=4
    vspeed-=rocketJumpStrength
    canRocketJump=0
    alarm[1]=rocketJumpCooldown
}
')

//Heavy turkey
globalvar TurkeyHeavy;
TurkeyHeavy=object_add()
object_event_add(TurkeyHeavy,ev_create,0,'
//Set values for all, save lines. Change specific properties by object basis
event_user(11)

//Movement values
runPower=0.3
walkPower=0.1

//Animation
sprite_index=TurkeyHeavyIdleS
mask_index=TurkeyHeavyMaskM
idleSprite=TurkeyHeavyIdleS
walkSprite=TurkeyHeavyS
flySprite=TurkeyHeavyFlyS
//FIX: characterHitObstacle needs these variables defined
left_bound_offset = sprite_get_bbox_left(sprite_index)-sprite_get_xoffset(sprite_index);
right_bound_offset = sprite_get_bbox_right(sprite_index)-sprite_get_xoffset(sprite_index);
top_bound_offset = sprite_get_bbox_top(sprite_index)-sprite_get_yoffset(sprite_index);
bottom_bound_offset = sprite_get_bbox_bottom(sprite_index)-sprite_get_yoffset(sprite_index);

//State
turkeyType=4

//Gamemode
weight=2
giveScore=4

//Special
oldRunPower=1
')
object_event_add(TurkeyHeavy,ev_other,ev_user1,'
//Reduce carrying player run power
with carryingPlayer{
    runPower=other.runPower
}
')
//Demo turkey
globalvar TurkeyDemo;
TurkeyDemo=object_add()
object_event_add(TurkeyDemo,ev_create,0,'
//Set values for all, save lines. Change specific properties by object basis
event_user(11)

//Animation
sprite_index=TurkeyDemoIdleS
mask_index=TurkeyDemoMaskM
idleSprite=TurkeyDemoIdleS
walkSprite=TurkeyDemoS
flySprite=TurkeyDemoFlyS
//FIX: characterHitObstacle needs these variables defined
left_bound_offset = sprite_get_bbox_left(sprite_index)-sprite_get_xoffset(sprite_index);
right_bound_offset = sprite_get_bbox_right(sprite_index)-sprite_get_xoffset(sprite_index);
top_bound_offset = sprite_get_bbox_top(sprite_index)-sprite_get_yoffset(sprite_index);
bottom_bound_offset = sprite_get_bbox_bottom(sprite_index)-sprite_get_yoffset(sprite_index);

//State
turkeyType=5

//Gamemode
weight=1
giveScore=2

//Special
canLayEgg=0
eggLayDelay=300
alarm[1]=eggLayDelay
eggLayAttemptTimer=120
alarm[3]=eggLayAttemptTimer
')
object_event_add(TurkeyDemo,ev_alarm,1,'
canLayEgg=1
')
object_event_add(TurkeyDemo,ev_alarm,3,'
if canLayEgg==1 and beingCarried==0 and captured==0{
    var rand;
    rand=irandom_range(0,10)

    //Change chance depending on distance to characters
    if distance_to_object(Character)>=150{
        if rand<=1{
            instance_create(x,y,EggBomb)
            canLayEgg=0
            alarm[1]=eggLayDelay
        }
    }else{
        if rand<=5{
            instance_create(x,y,EggBomb)
            canLayEgg=0
            alarm[1]=eggLayDelay
        }
    }
}
alarm[3]=eggLayAttemptTimer
')
object_event_add(TurkeyDemo,ev_other,ev_user1,'
//
')

//Egg bomb
globalvar EggBomb;
EggBomb=object_add()
object_event_add(EggBomb,ev_create,0,'
animationState=1
alarm[0]=29

stuck=0
depth=-3
sprite_index=EggBombS
mask_index=EggBombMaskM

blastRadius=35
')
object_event_add(EggBomb,ev_alarm,0,'
if animationState==1{
    animationState=0
    alarm[0]=1
}else{
    animationState=1
    alarm[0]=29
}
')
object_event_add(EggBomb,ev_step,ev_step_begin,'
//Falling
if stuck==0{
    vspeed+=0.2
}

//Explode
with(Character){
    if (distance_to_object(other)<=other.blastRadius){
        var rdir;
        rdir = point_direction(other.x ,other.y, (bbox_left+bbox_right)/2, (bbox_top+bbox_bottom)/2)
        if (1 - distance_to_object(other)/35 <= 0.25){
            continue;
        }
        motion_add(rdir,15)
        moveStatus=1
        with(other){
            instance_create(x,y,Explosion)
            playsound(x,y,ExplosionSnd)
            instance_destroy()
        }
    }
}

with(Rocket){
    if (distance_to_object(other)<=other.blastRadius){
        var rdir;
        rdir = point_direction(other.x ,other.y, (bbox_left+bbox_right)/2, (bbox_top+bbox_bottom)/2)
        if (1 - distance_to_object(other)/35 <= 0.25){
            continue;
        }
        motion_add(rdir,15)
        moveStatus=1
        with(other){
            instance_create(x,y,Explosion)
            playsound(x,y,ExplosionSnd)
            instance_destroy()
        }
    }
}

with(Mine){
    if (distance_to_object(other)<=other.blastRadius){
        var rdir;
        rdir = point_direction(other.x ,other.y, (bbox_left+bbox_right)/2, (bbox_top+bbox_bottom)/2)
        if (1 - distance_to_object(other)/35 <= 0.25){
            continue;
        }
        motion_add(rdir,15)
        moveStatus=1
        with(other){
            instance_create(x,y,Explosion)
            playsound(x,y,ExplosionSnd)
            instance_destroy()
        }
    }
}

with(Shot){
    if (distance_to_object(other)<=other.blastRadius){
        var rdir;
        rdir = point_direction(other.x ,other.y, (bbox_left+bbox_right)/2, (bbox_top+bbox_bottom)/2)
        if (1 - distance_to_object(other)/35 <= 0.25){
            continue;
        }
        motion_add(rdir,15)
        moveStatus=1
        with(other){
            instance_create(x,y,Explosion)
            playsound(x,y,ExplosionSnd)
            instance_destroy()
        }
    }
}

with(BurningProjectile){
    if (distance_to_object(other)<=other.blastRadius){
        var rdir;
        rdir = point_direction(other.x ,other.y, (bbox_left+bbox_right)/2, (bbox_top+bbox_bottom)/2)
        if (1 - distance_to_object(other)/35 <= 0.25){
            continue;
        }
        motion_add(rdir,15)
        moveStatus=1
        with(other){
            instance_create(x,y,Explosion)
            playsound(x,y,ExplosionSnd)
            instance_destroy()
        }
    }
}

with(BladeB){
    if (distance_to_object(other)<=other.blastRadius){
        var rdir;
        rdir = point_direction(other.x ,other.y, (bbox_left+bbox_right)/2, (bbox_top+bbox_bottom)/2)
        if (1 - distance_to_object(other)/35 <= 0.25){
            continue;
        }
        motion_add(rdir,15)
        moveStatus=1
        with(other){
            instance_create(x,y,Explosion)
            playsound(x,y,ExplosionSnd)
            instance_destroy()
        }
    }
}

with(Needle){
    if (distance_to_object(other)<=other.blastRadius){
        var rdir;
        rdir = point_direction(other.x ,other.y, (bbox_left+bbox_right)/2, (bbox_top+bbox_bottom)/2)
        if (1 - distance_to_object(other)/35 <= 0.25){
            continue;
        }
        motion_add(rdir,15)
        moveStatus=1
        with(other){
            instance_create(x,y,Explosion)
            playsound(x,y,ExplosionSnd)
            instance_destroy()
        }
    }
}
')
object_event_add(EggBomb,ev_collision,Obstacle,'
wallSetSolid()
really_move_contact_solid(direction, speed)
wallUnsetSolid()
speed=0
stuck=1
')
object_event_add(EggBomb,ev_draw,0,'
draw_sprite_ext(sprite_index,animationState,x,y,image_xscale,image_yscale,image_angle,c_white,1)
')
//Medic turkey
globalvar TurkeyMedic;
TurkeyMedic=object_add()
object_event_add(TurkeyMedic,ev_create,0,'
//Set values for all, save lines. Change specific properties by object basis
event_user(11)

//Animation
sprite_index=TurkeyMedicIdleS
mask_index=TurkeyMedicMaskM
idleSprite=TurkeyMedicIdleS
walkSprite=TurkeyMedicS
flySprite=TurkeyMedicFlyS
//FIX: characterHitObstacle needs these variables defined
left_bound_offset = sprite_get_bbox_left(sprite_index)-sprite_get_xoffset(sprite_index);
right_bound_offset = sprite_get_bbox_right(sprite_index)-sprite_get_xoffset(sprite_index);
top_bound_offset = sprite_get_bbox_top(sprite_index)-sprite_get_yoffset(sprite_index);
bottom_bound_offset = sprite_get_bbox_bottom(sprite_index)-sprite_get_yoffset(sprite_index);

//State
turkeyType=6

//Gamemode
weight=1
giveScore=2
')
object_event_add(TurkeyMedic,ev_other,ev_user1,'
//
')

//Engie turkey
globalvar TurkeyEngie;
TurkeyEngie=object_add()
object_event_add(TurkeyEngie,ev_create,0,'
//Set values for all, save lines. Change specific properties by object basis
event_user(11)

//Animation
sprite_index=TurkeyEngieIdleS
mask_index=TurkeyEngieMaskM
idleSprite=TurkeyEngieIdleS
walkSprite=TurkeyEngieS
flySprite=TurkeyEngieFlyS
//FIX: characterHitObstacle needs these variables defined
left_bound_offset = sprite_get_bbox_left(sprite_index)-sprite_get_xoffset(sprite_index);
right_bound_offset = sprite_get_bbox_right(sprite_index)-sprite_get_xoffset(sprite_index);
top_bound_offset = sprite_get_bbox_top(sprite_index)-sprite_get_yoffset(sprite_index);
bottom_bound_offset = sprite_get_bbox_bottom(sprite_index)-sprite_get_yoffset(sprite_index);

//State
turkeyType=7

//Gamemode
weight=1
giveScore=2

//Special
canMakeFake=0
makeFakeDelay=300
alarm[1]=makeFakeDelay
makeFakeAttemptTimer=120
alarm[3]=makeFakeAttemptTimer
')
object_event_add(TurkeyEngie,ev_alarm,3,'
canMakeFake=1
')
object_event_add(TurkeyEngie,ev_alarm,3,'
if canMakeFake==1 and beingCarried==0 and captured==0{
    var rand;
    rand=irandom_range(0,10)

    //Change chance depending on distance to characters
    if distance_to_object(Character)>=150{
        if rand<=1{
            instance_create(x,y,TurkeyFake)
            canMakeFake=0
            alarm[1]=makeFakeDelay
        }
    }else{
        if rand<=5{
            instance_create(x,y,TurkeyFake)
            canMakeFake=0
            alarm[1]=makeFakeDelay
        }
    }
}
alarm[3]=makeFakeAttemptTimer
')
object_event_add(TurkeyEngie,ev_other,ev_user1,'
//
')

//Fake turkey
globalvar TurkeyFake;
TurkeyFake=object_add()
object_event_add(TurkeyFake,ev_create,0,'
//Set values for all, save lines. Change specific properties by object basis
event_user(11)

//Animation
sprite_index=TurkeyNormalIdleS
mask_index=TurkeyNormalMaskM
idleSprite=TurkeyNormalIdleS
walkSprite=idleSprite
flySprite=TurkeyNormalFlyS
//FIX: characterHitObstacle needs these variables defined
left_bound_offset = sprite_get_bbox_left(sprite_index)-sprite_get_xoffset(sprite_index);
right_bound_offset = sprite_get_bbox_right(sprite_index)-sprite_get_xoffset(sprite_index);
top_bound_offset = sprite_get_bbox_top(sprite_index)-sprite_get_yoffset(sprite_index);
bottom_bound_offset = sprite_get_bbox_bottom(sprite_index)-sprite_get_yoffset(sprite_index);

//State
turkeyType=11

//Gamemode
weight=1
giveScore=0
')
object_event_add(TurkeyFake,ev_other,ev_user2,'
instance_create(x,y,TurkeyFizzle)
instance_destroy()
')

//Turkey fizzle
globalvar TurkeyFizzle;
TurkeyFizzle=object_add()
object_event_add(TurkeyFizzle,ev_create,0,'
sprite_index=TurkeyFizzleS
image_speed=7/30
vspeed=-0.1
alarm[1]=28
colour=c_white
darken=255
depth=-2
')
object_event_add(TurkeyFizzle,ev_alarm,1,'
instance_destroy()
')
object_event_add(TurkeyFizzle,ev_step,ev_step_normal,'
if random(4)<1{
    effect_create_below(ef_smokeup,x,y,0,c_gray)
}

darken+=6
colour=make_color_hsv(0,0,darken)
')
object_event_add(TurkeyFizzle,ev_draw,0,'
draw_sprite_ext(sprite_index,image_index,x,y,image_xscale,image_yscale,image_angle,colour,image_alpha)
')
//Spy turkey
globalvar TurkeySpy;
TurkeySpy=object_add()
object_event_add(TurkeySpy,ev_create,0,'
//Set values for all, save lines. Change specific properties by object basis
event_user(11)

//Animation
sprite_index=TurkeySpyIdleS
mask_index=TurkeySpyMaskM
idleSprite=TurkeySpyIdleS
walkSprite=TurkeySpyS
flySprite=TurkeySpyFlyS
//FIX: characterHitObstacle needs these variables defined
left_bound_offset = sprite_get_bbox_left(sprite_index)-sprite_get_xoffset(sprite_index);
right_bound_offset = sprite_get_bbox_right(sprite_index)-sprite_get_xoffset(sprite_index);
top_bound_offset = sprite_get_bbox_top(sprite_index)-sprite_get_yoffset(sprite_index);
bottom_bound_offset = sprite_get_bbox_bottom(sprite_index)-sprite_get_yoffset(sprite_index);

//State
turkeyType=0

//Gamemode
weight=1
giveScore=2

//Special
cloaked=0
canCloak=0
cloakTime=150
cloakCooldown=240
alarm[1]=cloakCooldown
')
object_event_add(TurkeySpy,ev_alarm,1,'
canCloak=1
')
object_event_add(TurkeySpy,ev_alarm,3,'
cloaked=0
image_alpha=1
alarm[1]=cloakCooldown
')
object_event_add(TurkeySpy,ev_alarm,4,'
image_alpha-=0.1
if image_alpha>0{
    alarm[4]=1
}
')
object_event_add(TurkeySpy,ev_other,ev_user1,'
if distance_to_object(Character)<=250 and canCloak==1{
    cloaked=1
    alarm[4]=1
    canCloak=0
    alarm[3]=cloakTime
}
')

//Sniper turkey
globalvar TurkeySniper;
TurkeySniper=object_add()
object_event_add(TurkeySniper,ev_create,0,'
//Set values for all, save lines. Change specific properties by object basis
event_user(11)

//Animation
sprite_index=TurkeySniperIdleS
mask_index=TurkeySniperMaskM
idleSprite=TurkeySniperIdleS
walkSprite=TurkeySniperS
flySprite=TurkeySniperFlyS
//FIX: characterHitObstacle needs these variables defined
left_bound_offset = sprite_get_bbox_left(sprite_index)-sprite_get_xoffset(sprite_index);
right_bound_offset = sprite_get_bbox_right(sprite_index)-sprite_get_xoffset(sprite_index);
top_bound_offset = sprite_get_bbox_top(sprite_index)-sprite_get_yoffset(sprite_index);
bottom_bound_offset = sprite_get_bbox_bottom(sprite_index)-sprite_get_yoffset(sprite_index);

//State
turkeyType=9

//Gamemode
weight=1
giveScore=2
')
object_event_add(TurkeySniper,ev_other,ev_user1,'
with(Character){
    testDist = distance_to_object(other)
    if(testDist<=1600){
        //if character x is greater than turkey x (on the right of turkey)
        if x>other.x{
            with(other){
                var avoidRand;
                avoidRand=irandom(6)
                if avoidRand==0{
                    idle=1
                }else if avoidRand>0{
                    runningLeft=1
                    runningRight=0
                    walkingRight=0
                }
            }
        }
        //if character x is less than turkey x (on the left of turkey)
        if x<other.x{
            with(other){
                var avoidRand;
                avoidRand=irandom(6)
                if avoidRand==0{
                    idle=1
                }else if avoidRand>0{
                    runningRight=1
                    runningLeft=0
                    walkingLeft=0
                }
            }
        }
    }
}
')
//Quote turkey
globalvar TurkeyQuote;
TurkeyQuote=object_add()
object_event_add(TurkeyQuote,ev_create,0,'
//Set values for all, save lines. Change specific properties by object basis
event_user(11)

//Animation
sprite_index=TurkeyQuoteIdleS
mask_index=TurkeyQuoteMaskM
idleSprite=TurkeyQuoteIdleS
walkSprite=TurkeyQuoteS
flySprite=TurkeyQuoteFlyS
//FIX: characterHitObstacle needs these variables defined
left_bound_offset = sprite_get_bbox_left(sprite_index)-sprite_get_xoffset(sprite_index);
right_bound_offset = sprite_get_bbox_right(sprite_index)-sprite_get_xoffset(sprite_index);
top_bound_offset = sprite_get_bbox_top(sprite_index)-sprite_get_yoffset(sprite_index);
bottom_bound_offset = sprite_get_bbox_bottom(sprite_index)-sprite_get_yoffset(sprite_index);

//State
turkeyType=10

//Gamemode
weight=1
giveScore=2

//Special
canFeather=0
featherDelay=40
alarm[1]=featherDelay
featherAttemptTimer=20
alarm[3]=featherAttemptTimer
')
object_event_add(TurkeyQuote,ev_alarm,1,'
canFeather=1
')
object_event_add(TurkeyQuote,ev_alarm,3,'
if canFeather==1 and beingCarried==0 and captured==0{
    var rand;
    rand=irandom_range(0,10)

    //Change chance depending on distance to characters
    if distance_to_object(Character)>=150{
        if rand<=2{
            instance_create(x,y,TurkeyFeather)
            canFeather=0
            alarm[1]=featherDelay
        }
    }else{
        if rand<=8{
            instance_create(x,y,TurkeyFeather)
            canFeather=0
            alarm[1]=featherDelay
        }
    }
}
alarm[3]=featherAttemptTimer
')
object_event_add(TurkeyQuote,ev_other,ev_user1,'
//
')

//Turkey feather
globalvar TurkeyFeather;
TurkeyFeather=object_add()
object_event_add(TurkeyFeather,ev_create,0,'
lifetime=180
alarm[0]=lifetime
turkeyOffset=-4
turkeyDir=0.3
depth=-3
sprite_index=TurkeyFeatherS
mask_index=TurkeyFeatherMaskM
')
object_event_add(TurkeyFeather,ev_alarm,0,'
instance_destroy()
')
object_event_add(TurkeyFeather,ev_step,ev_step_normal,'
y+=turkeyOffset

turkeyOffset+=turkeyDir
if (abs(turkeyOffset)>4){
    turkeyDir*=-1
}
')
object_event_add(TurkeyFeather,ev_collision,Rocket,'
event_user(0)
')
object_event_add(TurkeyFeather,ev_collision,Shot,'
event_user(0)
')
object_event_add(TurkeyFeather,ev_collision,Mine,'
event_user(0)
')
object_event_add(TurkeyFeather,ev_collision,Needle,'
event_user(0)
')
object_event_add(TurkeyFeather,ev_collision,BladeB,'
event_user(0)
')
object_event_add(TurkeyFeather,ev_collision,Bubble,'
event_user(0)
')
object_event_add(TurkeyFeather,ev_collision,BurningProjectile,'
event_user(0)
')
object_event_add(TurkeyFeather,ev_other,ev_user0,'
with(other){
    direction*=-1
    speed*=-1
    if team=TEAM_RED{
        team=TEAM_BLUE
    }else if team=TEAM_BLUE{
        team=TEAM_RED
    }
}

alarm[0]=1
')

//Set parent object for all turkeys
object_set_parent(TurkeyScout,Turkey)
object_set_parent(TurkeyPyro,Turkey)
object_set_parent(TurkeySoldier,Turkey)
object_set_parent(TurkeyHeavy,Turkey)
object_set_parent(TurkeyDemo,Turkey)
object_set_parent(TurkeyMedic,Turkey)
object_set_parent(TurkeyEngie,Turkey)
object_set_parent(TurkeyFake,Turkey)
object_set_parent(TurkeySpy,Turkey)
object_set_parent(TurkeySniper,Turkey)
object_set_parent(TurkeyQuote,Turkey)